#ifndef NetLoadD_Analysis
#define NetLoadD_Analysis

unsigned long kilobyte(unsigned long i)
	{ return i/1024; }

unsigned long megabyte(unsigned long i)
	{ return (i/1024)/1024; }

class Figure
 {
 public:
 unsigned long Rx;
 unsigned long Tx;
 };

class TRecord
 {
 public:
 unsigned long seconds;
 Figure total;
 Figure bps;
 Figure kbps;
 Figure mbps;
 void Analyse();
 TRecord(unsigned long sec, unsigned long rec, unsigned long trans);
 };

class TNetloadAnalysis
 {
 public:
 TRecord *Last;
 TRecord *Total;
 TNetloadAnalysis(TInterface *iface);
 ~TNetloadAnalysis();
 };


TNetloadAnalysis::TNetloadAnalysis(TInterface *iface)
 {

 Last=new TRecord(iface->TimeDiff, iface->RxDiff, iface->TxDiff);
 unsigned long tTimeDiff=iface->Last->seconds - iface->First->seconds;
 unsigned long tRxDiff=iface->Last->received - iface->First->received;
 unsigned long tTxDiff=iface->Last->transmitted - iface->First->transmitted;
 Total=new TRecord(tTimeDiff,tRxDiff,tTxDiff);
 }

TNetloadAnalysis::~TNetloadAnalysis()
 {
 delete Total;
 delete Last;
 }

TRecord::TRecord(unsigned long sec, unsigned long rec, unsigned long trans)
 {
 seconds=sec;
 total.Rx=rec;
 total.Tx=rec;
 Analyse();
 }

void TRecord::Analyse()
 {
 if (seconds<1) seconds=1;
 bps.Rx=total.Rx/seconds;
 bps.Tx=total.Tx/seconds;
 kbps.Rx=kilobyte(bps.Rx);
 kbps.Tx=kilobyte(bps.Tx);
 mbps.Rx=megabyte(bps.Rx);
 mbps.Tx=megabyte(bps.Tx);
 }

#endif
